(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/coercion'), require('@angular/common'), require('prismjs')) :
    typeof define === 'function' && define.amd ? define('@wizdm/prism', ['exports', '@angular/core', '@angular/cdk/coercion', '@angular/common', 'prismjs'], factory) :
    (global = global || self, factory((global.wizdm = global.wizdm || {}, global.wizdm.prism = {}), global.ng.core, global.ng.cdk.coercion, global.ng.common, global.prismjs));
}(this, (function (exports, core, coercion, common, ManualModePrism) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/highlighter/highlighter.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PrismHighlighter = /** @class */ (function () {
        function PrismHighlighter() {
            this.disabled = false;
        }
        Object.defineProperty(PrismHighlighter.prototype, "clazz", {
            /** Applies the proper classes to the host <pre> element */
            get: /**
             * Applies the proper classes to the host <pre> element
             * @return {?}
             */
            function () {
                return "wm-prism" + (this.disabled ? '' : ' language-none');
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrismHighlighter.prototype, "disableHighlight", {
            /** Disables the highlighting */
            set: /**
             * Disables the highlighting
             * @param {?} value
             * @return {?}
             */
            function (value) { this.disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        PrismHighlighter.decorators = [
            { type: core.Component, args: [{
                        selector: 'pre[wm-prism]',
                        template: "\n<code *ngIf=\"!disabled; else transclude\" [language]=\"language\" [wm-prism]=\"source\"></code>\n<ng-template #transclude>\n  <ng-content></ng-content>\n</ng-template>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: [""]
                    }] }
        ];
        PrismHighlighter.propDecorators = {
            clazz: [{ type: core.HostBinding, args: ['class',] }],
            disableHighlight: [{ type: core.Input, args: ['disabled',] }],
            language: [{ type: core.Input }],
            source: [{ type: core.Input, args: ['wm-prism',] }]
        };
        return PrismHighlighter;
    }());
    if (false) {
        /** @type {?} */
        PrismHighlighter.prototype.disabled;
        /**
         * Selects the language
         * @type {?}
         */
        PrismHighlighter.prototype.language;
        /**
         * Parses the source text
         * @type {?}
         */
        PrismHighlighter.prototype.source;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/tokenizer/tokenizer.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PrismTokenizer = /** @class */ (function () {
        function PrismTokenizer(prism) {
            this.prism = prism;
        }
        Object.defineProperty(PrismTokenizer.prototype, "language", {
            /** Selects the most appropriate grammar according to the language */
            set: /**
             * Selects the most appropriate grammar according to the language
             * @param {?} language
             * @return {?}
             */
            function (language) {
                this.grammar = !!language ? this.prism.languages[language] : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrismTokenizer.prototype, "source", {
            /** Tokenizes the input string or pass along the already tokenized array */
            set: /**
             * Tokenizes the input string or pass along the already tokenized array
             * @param {?} source
             * @return {?}
             */
            function (source) {
                this.tokens = typeof (source) === 'string' ? this.tokenize(source) : source;
            },
            enumerable: true,
            configurable: true
        });
        /** Helper for rendering strings */
        /**
         * Helper for rendering strings
         * @param {?} token
         * @return {?}
         */
        PrismTokenizer.prototype.isString = /**
         * Helper for rendering strings
         * @param {?} token
         * @return {?}
         */
        function (token) { return typeof (token) === 'string'; };
        /** Helper for rendering tokens */
        /**
         * Helper for rendering tokens
         * @param {?} token
         * @return {?}
         */
        PrismTokenizer.prototype.tokenClass = /**
         * Helper for rendering tokens
         * @param {?} token
         * @return {?}
         */
        function (token) {
            // Returns the basic token class + type and appends the aliases, if any 
            return token ? ('token ' + (token.type || '') + this.tokenAliases(token)) : '';
        };
        /**
         * @private
         * @param {?} token
         * @return {?}
         */
        PrismTokenizer.prototype.tokenAliases = /**
         * @private
         * @param {?} token
         * @return {?}
         */
        function (token) {
            // Skips when no aliases
            if (!token.alias) {
                return '';
            }
            // Appends the multiple aliases
            if (token.alias instanceof Array) {
                return token.alias.reduce((/**
                 * @param {?} c
                 * @param {?} alias
                 * @return {?}
                 */
                function (c, alias) { return c + ' ' + alias; }), '');
            }
            // Appends the single alias
            return ' ' + token.alias;
        };
        /**
         * @private
         * @param {?} source
         * @return {?}
         */
        PrismTokenizer.prototype.tokenize = /**
         * @private
         * @param {?} source
         * @return {?}
         */
        function (source) {
            // Skips invalid source
            if (!source) {
                return [''];
            }
            // Returns the full text as a single token when no grammar is defined
            if (!this.grammar) {
                return [source];
            }
            // Tokenize the source code according to the selected grammar
            return this.prism.tokenize(source, this.grammar);
        };
        PrismTokenizer.decorators = [
            { type: core.Component, args: [{
                        selector: ':not(pre)[wm-prism]',
                        template: "<!-- Loops on tokens -->\n<ng-container *ngFor=\"let token of tokens\">\n\n  <!-- Renders plain strings as text nodes -->\n  <ng-container *ngIf=\"isString(token); else spanToken\">{{ token }}</ng-container>\n\n  <!-- Spans the token recurring down the tree with the proper styling otherwise -->\n  <ng-template #spanToken>\n    <span [class]=\"tokenClass(token)\" [wm-prism]=\"token.content\"></span>\n  </ng-template>\n\n</ng-container>\n"
                    }] }
        ];
        /** @nocollapse */
        PrismTokenizer.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: ['prism',] }] }
        ]; };
        PrismTokenizer.propDecorators = {
            language: [{ type: core.Input }],
            source: [{ type: core.Input, args: ['wm-prism',] }]
        };
        return PrismTokenizer;
    }());
    if (false) {
        /** @type {?} */
        PrismTokenizer.prototype.tokens;
        /**
         * @type {?}
         * @private
         */
        PrismTokenizer.prototype.grammar;
        /**
         * @type {?}
         * @private
         */
        PrismTokenizer.prototype.prism;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/prism-manual-mode.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Forces prism to run in manual mode
    ((/**
     * @param {?} window
     * @return {?}
     */
    function (window) {
        window.Prism = (window.Prism || {});
        window.Prism.manual = true;
    })(window || {}));

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/prism.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = ManualModePrism;
    var PrismModule = /** @class */ (function () {
        function PrismModule() {
        }
        PrismModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [
                            PrismHighlighter,
                            PrismTokenizer
                        ],
                        exports: [
                            PrismHighlighter,
                            PrismTokenizer
                        ],
                        providers: [{ provide: 'prism', useValue: ɵ0 }]
                    },] }
        ];
        return PrismModule;
    }());

    exports.PrismHighlighter = PrismHighlighter;
    exports.PrismModule = PrismModule;
    exports.PrismTokenizer = PrismTokenizer;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=wizdm-prism.umd.js.map
